﻿Imports BenchmarkDotNet.Attributes
Imports Microsoft.EntityFrameworkCore

Public Class EfTest3
    <Benchmark>
    Public Sub EF_über_Entitys_mit_Tracking()
        Using ctx As New Context.PersonContext
            ctx.Person.Skip(10).Take(10000).Where(Function(p) p.FirstName.StartsWith("Vor") AndAlso p.LastName.StartsWith("Nach")).OrderBy(Function(o) o.Id).AsTracking.Load
        End Using
    End Sub

    <Benchmark>
    Public Sub EF_über_Entitys_ohne_Tracking()
        Using ctx As New Context.PersonContext
            ctx.Person.Skip(10).Take(10000).Where(Function(p) p.FirstName.StartsWith("Vor") AndAlso p.LastName.StartsWith("Nach")).OrderBy(Function(o) o.Id).AsNoTracking.Load
        End Using
    End Sub

    <Benchmark>
    Public Sub EF_über_ExecuteSql_mit_Tracking()
        Using ctx As New Context.PersonContext
            ctx.Person.FromSql("SELECT * FROM dbo.Person WHERE FirstName LIKE 'Vor%' AND LastName LIKE 'Nach%' ORDER BY id OFFSET 10 ROWS FETCH NEXT 10000 ROWS ONLY").Load
        End Using
    End Sub

    <Benchmark>
    Public Sub EF_über_ExecuteSql_ohne_Tracking()
        Using ctx As New Context.PersonContext
            ctx.Person.FromSql("SELECT * FROM dbo.Person WHERE FirstName LIKE 'Vor%' AND LastName LIKE 'Nach%' ORDER BY id OFFSET 10 ROWS FETCH NEXT 10000 ROWS ONLY").AsNoTracking.Load
        End Using
    End Sub
End Class
