﻿Imports BenchmarkDotNet.Attributes
Imports Microsoft.EntityFrameworkCore

Public Class EfTest4

    <Benchmark>
    Public Sub EF_über_Entitys_mit_Tracking()
        Using ctx As New Context.PersonContext
            Dim persons = ctx.Person.Where(Function(p) p.Id >= 1000 AndAlso p.Id < 2000).AsTracking.ToList
            For Each p In persons
                p.Zip = "99999"
            Next
            ctx.SaveChanges()
        End Using
    End Sub

    <Benchmark>
    Public Sub EF_über_Entitys_ohne_Tracking()
        Using ctx As New Context.PersonContext
            Dim persons = ctx.Person.Where(Function(p) p.Id >= 1000 AndAlso p.Id < 2000).AsNoTracking.ToList
            For Each p In persons
                p.Zip = "99999"
                ctx.ChangeTracker.TrackGraph(p, Function(e) e.Entry.State = EntityState.Modified)
            Next
            ctx.SaveChanges()
        End Using
    End Sub

    <Benchmark>
    Public Sub EF_über_ExecuteSql()
        Using ctx As New Context.PersonContext
            ctx.Database.ExecuteSqlCommand("UPDATE dbo.Person SET Zip = '99999' WHERE Id >= 1000 And Id < 2000")
        End Using
    End Sub

End Class
